# Please keep this package in sync with FC

%define api		1.0
%define major		0
%define libname		%mklibname %{name} %{api} %{major}
%define giname		%mklibname gtkvnc-gir %{api}
%define develname	%mklibname -d %{name} %{api}

%define gtk3_api	2.0
%define gtk3_major	0
%define gtk3_libname	%mklibname %{name} %{gtk3_api} %{gtk3_major}
%define gtk3_giname	%mklibname gtkvnc-gir %{gtk3_api}
%define gtk3_develname	%mklibname -d %{name} %{gtk3_api}

%define gvnc_api	1.0
%define gvnc_major	0
%define gvnc_libname	%mklibname gvnc %{gvnc_api} %{gvnc_major}
%define gvnc_giname	%mklibname gvnc-gir %{gvnc_api}
%define gvnc_develname	%mklibname gvnc %{gvnc_api} -d

%define url_ver	%{lua: ver = rpm.expand("%{version}"); majmin, count1 = string.gsub(ver, "^([0123456789]+%.[0123456789]+).*", "%1", 1); if count1 == 0 then print(ver); return; end; maj, count2 = string.gsub(majmin, "^([0123456789]+).*", "%1", 1); if count2 == 0 then print(majmin) elseif tonumber(majmin) < 40 then print(majmin) else print(maj) end}

%global with_mingw 0

%if 0%{?mageia}
%global with_mingw 1
%endif

Summary:	A GTK widget for VNC clients
Name:		gtk-vnc
Version:	1.3.1
Release:	%mkrel 4
License:	LGPLv2+
Group:		System/Libraries
Url:		https://gtk-vnc.sourceforge.net/
Source0:	https://download.gnome.org/sources/%{name}/%{url_ver}/%{name}-%{version}.tar.xz
BuildRequires:	pkgconfig(gtk+-3.0)
BuildRequires:	python3
BuildRequires:	pkgconfig(gnutls)
BuildRequires:	pkgconfig(libsasl2)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	perl(Text::CSV)
BuildRequires:	pkgconfig(libgcrypt)
BuildRequires:	vala-tools
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	gettext-devel
BuildRequires:	meson

%if %{with_mingw}
BuildRequires: mingw32-filesystem >= 95
BuildRequires: mingw32-gcc
BuildRequires: mingw32-cairo
BuildRequires: mingw32-gettext
BuildRequires: mingw32-libgcrypt
BuildRequires: mingw32-gnutls
BuildRequires: mingw32-gtk3


BuildRequires: mingw64-filesystem >= 95
BuildRequires: mingw64-gcc
BuildRequires: mingw64-cairo
BuildRequires: mingw64-gettext
BuildRequires: mingw64-libgcrypt
BuildRequires: mingw64-gnutls
BuildRequires: mingw64-gtk3
%endif

%description
gtk-vnc is a VNC viewer widget for GTK. It is built using 
coroutines allowing it to be completely asynchronous while 
remaining single threaded. It provides a core C library, and
bindings for Python (PyGTK)

%package i18n
Summary:	A VNC viewer widget for GTK
Group:		System/Libraries
Obsoletes:	%{name}-common < 0.4.4
BuildArch:	noarch

%description i18n
gtk-vnc is a VNC viewer widget for GTK. It is built using 
coroutines allowing it to be completely asynchronous while 
remaining single threaded. It provides a core C library, and
bindings for Python (PyGTK)

This package contains translations used by gtk-vnc

%package -n %{gtk3_libname}
Summary:	A VNC viewer widget for GTK3
Group:		System/Libraries

%description -n %{gtk3_libname}
Runtime library for the GTK+ 3.x VNC widget.

%package -n %{gtk3_giname}
Summary:	GObject Introspection interface library for %{name}
Group:		System/Libraries
Requires:	%{gtk3_libname} = %{version}-%{release}

%description -n %{gtk3_giname}
GObject Introspection interface library for %{name}.

%package -n %{gtk3_develname}
Summary:	Headers and development library for gtk3-vnc
Group:		Development/C
Requires:	%{gtk3_libname} = %{version}-%{release}
Requires:	%{gtk3_giname} = %{version}-%{release}
Provides:	lib%{name}%{gtk3_api}-devel = %{version}-%{release}

%description -n %{gtk3_develname}
Development support for the GTK+ 3.x VNC widget.

%package -n %{gvnc_libname}
Summary:	Core library for %{name}
Group:		System/Libraries
Requires:	%{name}-i18n >= %{version}-%{release}
Conflicts:	%{libname} < 0.4.3-2

%description -n %{gvnc_libname}
Runtime core library for %{name}.

%package -n %{gvnc_giname}
Summary:	GObject Introspection interface library for gvnc
Group:		System/Libraries
Requires:	%{gvnc_libname} = %{version}-%{release}

%description -n %{gvnc_giname}
GObject Introspection interface library for gvnc.

%package -n %{gvnc_develname}
Summary:	Header files for core library of %{name}
Group:		Development/C
Requires:	%{gvnc_libname} = %{version}-%{release}
Requires:	%{gvnc_giname} = %{version}-%{release}
Provides:	libgvnc%{gvnc_api}-devel = %{version}-%{release}

%description -n %{gvnc_develname}
Development files for core library of %{name}.

%if %{with_mingw}
# Mingw32
%package -n mingw32-gvnc
Summary: MinGW Windows port of VNC GObject
BuildArch: noarch

%package -n mingw32-gvnc-tools
Summary: Command line VNC tools
BuildArch: noarch

%package -n mingw32-gtk-vnc2
Summary: A GTK3 widget for VNC clients
Requires: pkgconfig
Obsoletes: mingw32-gtk-vnc < 1.0.0
BuildArch: noarch

%description -n mingw32-gvnc
gvnc is a GObject for managing a VNC connection. It provides all the
infrastructure required to build a VNC client without having to deal
with the raw protocol itself.

%description -n mingw32-gvnc-tools
Provides useful command line utilities for interacting with
VNC servers. Includes the gvnccapture program for capturing
screenshots of a VNC desktop

%description -n mingw32-gtk-vnc2
gtk-vnc is a VNC viewer widget for GTK. It is built using coroutines
allowing it to be completely asynchronous while remaining single threaded.

# Mingw64
%package -n mingw64-gvnc
Summary: MinGW Windows port of VNC GObject
BuildArch: noarch

%package -n mingw64-gvnc-tools
Summary: Command line VNC tools
BuildArch: noarch

%package -n mingw64-gtk-vnc2
Summary: A GTK3 widget for VNC clients
Requires: pkgconfig
Obsoletes: mingw64-gtk-vnc < 1.0.0
BuildArch: noarch

%description -n mingw64-gvnc
gvnc is a GObject for managing a VNC connection. It provides all the
infrastructure required to build a VNC client without having to deal
with the raw protocol itself.

%description -n mingw64-gvnc-tools
Provides useful command line utilities for interacting with
VNC servers. Includes the gvnccapture program for capturing
screenshots of a VNC desktop

%description -n mingw64-gtk-vnc2
gtk-vnc is a VNC viewer widget for GTK. It is built using coroutines
allowing it to be completely asynchronous while remaining single threaded.

%{?mingw_debug_package}
%endif

%prep
%autosetup -n gtk-vnc-%{version}

%build
%meson
%meson_build

%if %{with_mingw}
%mingw_meson -Dintrospection=disabled
%mingw_ninja
%endif


%install
%meson_install

%find_lang %{name}

%if %{with_mingw}
export DESTDIR=%{buildroot}
%mingw_ninja install

rm -f $RPM_BUILD_ROOT%{mingw32_mandir}/man1/gvnccapture.1*
rm -f $RPM_BUILD_ROOT%{mingw64_mandir}/man1/gvnccapture.1*

%mingw_debug_install_post

%mingw_find_lang gtk-vnc
%endif

%check
%meson_test

%files
%{_bindir}/gvnccapture
%{_mandir}/man1/gvnccapture.1*

%files -n %{gvnc_libname}
%doc README NEWS AUTHORS
%{_libdir}/libgvnc-%{api}.so.%{major}{,.*}
%{_libdir}/libgvncpulse-%{api}.so.%{major}{,.*}

%files -n %{gvnc_giname}
%{_libdir}/girepository-1.0/GVnc-%{api}.typelib
%{_libdir}/girepository-1.0/GVncPulse-%{api}.typelib

%files -n %{gvnc_develname}
%{_libdir}/libgvnc-%{api}.so
%{_libdir}/libgvncpulse-%{api}.so
%{_libdir}/pkgconfig/gvnc-%{api}.pc
%{_libdir}/pkgconfig/gvncpulse-%{api}.pc
%{_includedir}/gvnc-%{api}
%{_includedir}/gvncpulse-%{api}
%{_datadir}/gir-1.0/GVnc-%{api}.gir
%{_datadir}/gir-1.0/GVncPulse-%{api}.gir
%{_datadir}/vala/vapi/gvnc-%{api}.deps
%{_datadir}/vala/vapi/gvnc-%{api}.vapi
%{_datadir}/vala/vapi/gvncpulse-%{api}.deps
%{_datadir}/vala/vapi/gvncpulse-%{api}.vapi

%files -n %{gtk3_libname}
%{_libdir}/libgtk-vnc-%{gtk3_api}.so.%{gtk3_major}{,.*}

%files -n %{gtk3_giname}
%{_libdir}/girepository-1.0/GtkVnc-%{gtk3_api}.typelib

%files -n %{gtk3_develname}
%{_libdir}/libgtk-vnc-%{gtk3_api}.so
%{_includedir}/%{name}-%{gtk3_api}
%{_libdir}/pkgconfig/%{name}-%{gtk3_api}.pc
%{_datadir}/gir-1.0/GtkVnc-%{gtk3_api}.gir
%{_datadir}/vala/vapi/gtk-vnc-%{gtk3_api}.deps
%{_datadir}/vala/vapi/gtk-vnc-%{gtk3_api}.vapi

%files i18n -f %{name}.lang

%if %{with_mingw}
# Mingw32
%files -n mingw32-gvnc -f mingw32-gtk-vnc.lang
%doc AUTHORS
%doc ChangeLog
%doc ChangeLog-old
%doc NEWS
%doc README
%doc COPYING.LIB
%{mingw32_bindir}/libgvnc-1.0-0.dll
%{mingw32_libdir}/libgvnc-1.0.dll.a
%{mingw32_libdir}/pkgconfig/gvnc-1.0.pc
%{mingw32_includedir}/gvnc-1.0

%files -n mingw32-gtk-vnc2
%{mingw32_bindir}/libgtk-vnc-2.0-0.dll
%{mingw32_libdir}/libgtk-vnc-2.0.dll.a
%{mingw32_libdir}/pkgconfig/gtk-vnc-2.0.pc
%{mingw32_includedir}/gtk-vnc-2.0

%files -n mingw32-gvnc-tools
%{mingw32_bindir}/gvnccapture.exe

# Mingw64
%files -n mingw64-gvnc -f mingw64-gtk-vnc.lang
%doc AUTHORS
%doc ChangeLog
%doc ChangeLog-old
%doc NEWS
%doc README
%doc COPYING.LIB
%{mingw64_bindir}/libgvnc-1.0-0.dll
%{mingw64_libdir}/libgvnc-1.0.dll.a
%{mingw64_libdir}/pkgconfig/gvnc-1.0.pc
%{mingw64_includedir}/gvnc-1.0

%files -n mingw64-gtk-vnc2
%{mingw64_bindir}/libgtk-vnc-2.0-0.dll
%{mingw64_libdir}/libgtk-vnc-2.0.dll.a
%{mingw64_libdir}/pkgconfig/gtk-vnc-2.0.pc
%{mingw64_includedir}/gtk-vnc-2.0

%files -n mingw64-gvnc-tools
%{mingw64_bindir}/gvnccapture.exe
%endif



%changelog
* Sun Dec 25 2022 pterjan <pterjan> 1.3.1-4.mga9
+ Revision: 1926895
- Use per-package .lang for mingw subpackages
+ daviddavid <daviddavid>
- rebuild with fixed mingw-filesystem

* Sun Nov 06 2022 tv <tv> 1.3.1-2.mga9
+ Revision: 1904032
- Pull in mingw sub-packages

* Thu Jul 14 2022 ovitters <ovitters> 1.3.1-1.mga9
+ Revision: 1868828
- new version 1.3.1

* Wed Mar 30 2022 umeabot <umeabot> 1.3.0-2.mga9
+ Revision: 1835685
- Mageia 9 Mass Rebuild

* Tue Nov 23 2021 tv <tv> 1.3.0-1.mga9
+ Revision: 1758726
- 1.3.0

* Wed Apr 14 2021 tv <tv> 1.2.0-1.mga9
+ Revision: 1715737
- 1.2.0

* Sat Feb 15 2020 umeabot <umeabot> 1.0.0-3.mga8
+ Revision: 1528125
- Mageia 8 Mass Rebuild

* Thu Aug 08 2019 tv <tv> 1.0.0-2.mga8
+ Revision: 1428276
- run testsuite
- new release
- switch to meson
- only build gtk+3 widget, drop gtk+2 one

* Tue Sep 04 2018 tv <tv> 0.9.0-3.mga8
+ Revision: 1257142
- Fix gvnc-1.0.pc file version dep

* Tue Aug 28 2018 tv <tv> 0.9.0-2.mga7
+ Revision: 1255261
- Fix crash if connection fails early (rhbz#1620203)

* Sun Aug 19 2018 tv <tv> 0.9.0-1.mga7
+ Revision: 1252839
- new release

* Thu Aug 02 2018 daviddavid <daviddavid> 0.8.0-1.mga7
+ Revision: 1246807
- new version: 0.8.0
- deleted the python2 binding in favour of GObject introspection (upstream)

* Wed May 09 2018 tv <tv> 0.7.2-2.mga7
+ Revision: 1227863
- rename python-gtk-vnc as python2-gtk-vnc

* Thu Mar 29 2018 tv <tv> 0.7.2-1.mga7
+ Revision: 1213396
- BR pulseaudio-devel & uncomment gvncpulse
- new release

* Fri Feb 10 2017 mrambo3501 <mrambo3501> 0.6.0-3.mga6
+ Revision: 1085640
- Add upstream patches which fix CVE-2017-5884 and CVE-2017-5885
  Add patch to fix the connection test code based upon upstream code
- Add upstream patches which fix CVE-2017-5884 and CVE-2017-5885
  Add patch to fix the connection test code based upon upstream code

* Mon Sep 26 2016 tv <tv> 0.6.0-2.mga6
+ Revision: 1056886
- rebuild with fixed rpm-mageia-setup for missing generating typelib() requires (mga#19454)

* Sun Sep 18 2016 ovitters <ovitters> 0.6.0-1.mga6
+ Revision: 1053842
- new version 0.6.0

* Mon Jan 11 2016 luigiwalser <luigiwalser> 0.5.4-5.mga6
+ Revision: 921915
- add patch to fix python linking error
- rebuild for gnutls

* Mon Sep 14 2015 fwang <fwang> 0.5.4-4.mga6
+ Revision: 879059
- rebuild for new libgcrypt

* Mon Jun 29 2015 wally <wally> 0.5.4-3.mga6
+ Revision: 847599
- bump rel as PEM (Package Eating Monster) ate previous one

* Mon Jun 29 2015 wally <wally> 0.5.4-2.mga6
+ Revision: 847493
- add requires for gir pkg to devel pkg

* Sat Jun 20 2015 ovitters <ovitters> 0.5.4-1.mga6
+ Revision: 836290
- new version 0.5.4

* Wed Oct 15 2014 umeabot <umeabot> 0.5.3-6.mga5
+ Revision: 743694
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 0.5.3-5.mga5
+ Revision: 726455
- rebuild for missing pythoneggs deps

* Fri Sep 26 2014 wally <wally> 0.5.3-4.mga5
+ Revision: 724903
- rebuild with new rpm-mageia-setup to generate requires for .typelib files

* Tue Sep 16 2014 umeabot <umeabot> 0.5.3-3.mga5
+ Revision: 680008
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 0.5.3-2.mga4
+ Revision: 535130
- Mageia 4 Mass Rebuild

* Wed Sep 18 2013 ovitters <ovitters> 0.5.3-1.mga4
+ Revision: 481178
- new version 0.5.3

* Tue Aug 27 2013 luigiwalser <luigiwalser> 0.5.2-2.mga4
+ Revision: 472073
- rebuild for cyrus-sasl

* Wed Jun 26 2013 dams <dams> 0.5.2-1.mga4
+ Revision: 446673
- new version 0.5.2
- removes mozilla plugin subpackage as it no longer exists

* Sat Jan 12 2013 umeabot <umeabot> 0.5.1-3.mga3
+ Revision: 352868
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Jul 20 2012 ovitters <ovitters> 0.5.1-2.mga3
+ Revision: 272709
- i18n is noarch

* Thu Jul 19 2012 ovitters <ovitters> 0.5.1-1.mga3
+ Revision: 272662
- new version 0.5.1

* Thu Dec 22 2011 wally <wally> 0.5.0-1.mga3
+ Revision: 186006
- new version 0.5.0

* Fri Nov 11 2011 wally <wally> 0.4.4-1.mga2
+ Revision: 166712
- new version 0.4.4
- rediff P1
- rename common pkg to i18n
- clean .spec a bit
+ fwang <fwang>
- build gtk2 flavour
- rebuild with new gnutls, and turn to gtk3 flavour

* Sat Jul 09 2011 cjw <cjw> 0.4.3-5.mga2
+ Revision: 121237
- put gobject introspection typelib files in separate subpackages
- rebuild for automatic typelib provides and deps

* Tue Jul 05 2011 cjw <cjw> 0.4.3-4.mga2
+ Revision: 119002
- drop libtool libraries to fix vinagre build

* Thu Jun 23 2011 ze <ze> 0.4.3-3.mga2
+ Revision: 112571
- add missing buildrequire libgcrypt-devel
- add missing conflict (upgrade broke)

* Sun Jun 19 2011 cjw <cjw> 0.4.3-2.mga2
+ Revision: 110104
- put libgvnc in a separate package so the gtk3 lib doesn't pull in the gtk2 lib
- also build a gtk3 version

* Fri Feb 25 2011 ennael <ennael> 0.4.3-1.mga1
+ Revision: 59397
- imported package gtk-vnc

